// ============================================================                                                            
// C64-SPS: Testcode for DI and DO board - Nano firmware
// ============================================================ 
// Descripton: 
// Arduino sketch does: 
// - write to DO board (counter 00 --> FF)
// - read DI board - changes give output oon serial terminal
// ============================================================ 



#define AMOUNT_IC   1           // amount of used 74HC165 chips
#define DATA_WIDTH  AMOUNT_IC * 8


// --- 74165 defines -----
#define PIN_PL  17
#define PIN_Q7  16
#define PIN_CLK 15

byte cntRead = 0;


// --- 74595 defines -----
#define PIN_SHIFT 15  // connected to SHCP
#define PIN_STORE 13  // connected to STCP
#define PIN_DATA  14  // connected to DS



byte count = 0;


// Binary count from 0-255:
// 1 = 000000001
// 2 = 000000010
// 3 = 000000011
// 4 = 000000100
// 5 = 000000101
// etc.




unsigned long pinValues, oldPinValues = 0xa5a5;



void setup()
{
  Serial.begin(115200);

  // --- 74165 defines -----
  pinMode(PIN_PL, OUTPUT);
  //pinMode(PIN_CE, OUTPUT);
  pinMode(PIN_CLK, OUTPUT);
  pinMode(PIN_Q7, INPUT);

  digitalWrite(PIN_CLK, LOW);
  digitalWrite(PIN_PL, HIGH);

  //pinValues = readShiftRegisters();
  //printByte();
  //oldPinValues = pinValues;


  // --- 74595 defines -----
  pinMode(PIN_STORE, OUTPUT);
  pinMode(PIN_SHIFT, OUTPUT);
  pinMode(PIN_DATA, OUTPUT);

  digitalWrite(PIN_STORE, LOW);
  shiftOut(PIN_DATA, PIN_SHIFT, LSBFIRST, count);
  digitalWrite(PIN_STORE, HIGH);
}

void loop()
{
  // --- 74165 defines -----
  if(cntRead++ > 0)
  {
    cntRead = 0;
    pinValues = readShiftRegisters();
    if (pinValues != oldPinValues) 
    {
        printByte();
        oldPinValues = pinValues;
    }
  }


  // --- 74595 defines -----
  //shiftOut(PIN_DATA, PIN_SHIFT, LSBFIRST, count++);
  writeShiftRegisters(count++);


  delay(100);
}

void writeShiftRegisters(uint8_t pOut)
{
    byte bitVal;
    unsigned long bytesVal = 0;

    for (byte i = 0; i < 8; i++) 
    {
        bitVal = pOut & (1 << i) ? 1 : 0;
        digitalWrite(PIN_DATA, bitVal);
        digitalWrite(PIN_SHIFT, HIGH);
        delayMicroseconds(5);
        digitalWrite(PIN_SHIFT, LOW);
    }

    digitalWrite(PIN_STORE, LOW);
    delayMicroseconds(5);
    digitalWrite(PIN_STORE, HIGH);
}

unsigned long readShiftRegisters()
{
    long bitVal;
    unsigned long bytesVal = 0;

    //digitalWrite(PIN_CE, HIGH);
    digitalWrite(PIN_PL, LOW);
    delayMicroseconds(5);
    digitalWrite(PIN_PL, HIGH);
    //digitalWrite(PIN_CE, LOW);

    for (byte i = 0; i < DATA_WIDTH; i++) {
        bitVal = digitalRead(PIN_Q7);
        bytesVal |= (bitVal << ((DATA_WIDTH - 1) - i));

        digitalWrite(PIN_CLK, HIGH);
        delayMicroseconds(5);
        digitalWrite(PIN_CLK, LOW);
    }

    return (bytesVal);
}

void printByte()
{
    for (byte i = 0; i <= DATA_WIDTH - 1; i++) {
     Serial.print("D" + String(i) + " ");
    }
    Serial.println("");
    for (byte i = 0; i <= DATA_WIDTH - 1; i++) {
        Serial.print(pinValues >> i & 1, BIN);
        if(i > 9)   Serial.print("   ");
        else        Serial.print("  ");
    }

    Serial.println("\n");
}
